// reads a line from stdin- replaces \n with \0
// allocates space and sets input to its address

// returns the number of characters read, not including the \0

// the first time you call it, set input to NULL

// input can be reused- if not NULL it's realloc'd to the initial size

// to avoid memory leaks and crashes, if you free(input) be sure to set it
// to NULL too

// the optional second parameter is a file pointer, defaults to stdin

#include <string.h>
#include <stdlib.h>
#define INIT_STRLEN (128)

int getString(char **input, FILE *fp=stdin) {
  int size = INIT_STRLEN ;

  if (!*input) 
    *input = (char *) malloc(INIT_STRLEN) ;
  else
    *input = (char *) realloc(*input, INIT_STRLEN) ;

  int i = 0 ;
  int c ;
  while(1) {
    c = getc(fp) ;
    if (c=='\n'|| c==EOF) {
      (*input)[i] = '\0' ;
      return c ;
    } else
      (*input)[i] = c ;
    i++ ;
    if (i==size) {
      size+=INIT_STRLEN ;
      *input = (char *) realloc(*input, size) ;
    }
  }
}

